/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "gpsdate.hh"

const long gpst0 = 432000; // Offset of gps 0 from sart of year
const int gpsy0 = 1980; // First year.
const int cycle = 1461; // Number of days in a leap-year cycle = 365*3 + 366

//======================================  Calculate the gps date
gps_date::gps_date(long gps) {
    int dayInEpoch = (gps + gpst0) / 86400L;
    mYear = gpsy0 + 4 * int(dayInEpoch / cycle); // first year in cycle
    mHour = int(gps / 3600) % 24;
    int dayInCycle = dayInEpoch % cycle;
    if (dayInCycle < 366) {
	mDayInYear = dayInCycle;
    }
    else {
	mYear += (dayInCycle - 1) / 365;
	mDayInYear = (dayInCycle - 1) % 365;
    }
}

//======================================  Destroy the gps date
gps_date::~gps_date(void) {
}
